(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = global || self, factory(global['vue-link-pre'] = {}));
}(this, (function (exports) { 'use strict';

  var validateAs = function (type) { return ['', 'script', 'style', 'image', 'media', 'document', 'font'].indexOf(type) > -1; };
  var validateRel = function (type) { return ['preload', 'prefetch'].indexOf(type) > -1; };
  var domTokenListSupports = function () {
      try {
          return document.createElement('link').relList.supports('preload');
      }
      catch (e) {
          // link[rel=preload] is not supported
          console.warn('link[rel=preload] is not supported');
          return false;
      }
  };
  var VueLinkPre = {
      install: function (Vue) {
          var isSupported;
          var init = function () {
              isSupported = domTokenListSupports();
              if (!isSupported)
                  console.info('Current browser does not support link[rel=preload] functionality');
          };
          Vue.addPreLink = function (elementHref, elementAs, elementRel) {
              if (!isSupported)
                  return;
              if (elementAs === undefined)
                  elementAs = 'script';
              if (!validateAs(elementAs))
                  return;
              if (elementRel === undefined)
                  elementRel = 'preload';
              if (!validateRel(elementRel))
                  return;
              var lnk = document.createElement('link');
              var rel = document.createAttribute('rel');
              rel.value = elementRel;
              lnk.setAttributeNode(rel);
              var as = document.createAttribute('as');
              as.value = elementAs;
              lnk.setAttributeNode(as);
              var href = document.createAttribute('href');
              href.value = elementHref;
              lnk.setAttributeNode(href);
              document.head.appendChild(lnk);
          };
          Vue.preGroup = function (resourcesMap, elementRel) {
              var _loop_1 = function (key, value) {
                  if (validateAs(key) && value.length) {
                      value.forEach(function (item) { return Vue.addPreLink(item, key, elementRel); });
                  }
              };
              for (var _i = 0, _a = Object.entries(resourcesMap); _i < _a.length; _i++) {
                  var _b = _a[_i], key = _b[0], value = _b[1];
                  _loop_1(key, value);
              }
          };
          init();
      },
  };

  exports.default = VueLinkPre;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
